/*****************************************************************************
 *                                                                           *
 *     Class definition for the mailer                                       *
 *     Version 1.0                        Author      :    Henry Koplien     *
 *                                        Create date :    19.11.98          *
 *                                        Last edit   :    27.11.98          *
 *****************************************************************************/
#include "global.hpp"
#include "mail.hpp"

/***********************************************************************
 *  Name:        send.                                                 *
 *  Parameter:   String to send.                                       *
 *  Return:      Nothing.                                              *
 *  Function:    Sends text via mail.                                  *
 *               We try to make no noise...                            *
 ***********************************************************************/
void mail::send(const char *text) {
FILE   *Message, *Mailer;
string local_time, host;
time_t temp;

  if ((temp = time(NULL)) == -1)
    strcpy(local_time, "No Time Available");
  else
    strcpy(local_time, ctime(&temp));

  if (gethostname(host, STRLEN-1) == -1)
    strcpy(host, "No Host Available");

  if ((Message=fopen("/tmp/UPSMess", "w")) != NULL) {
    fprintf(Message, "This is an automated mail, build at...\n\n");
    fprintf(Message, "      Local time        : %s", local_time);
    fprintf(Message, "      Host              : %s\n", host);
    fprintf(Message, "      Product date      : %s\n", DATE);
    fprintf(Message, "      Version           : %s\n", VERSION);
    fprintf(Message, "      Termination reason: %s\n\n", text);
    fprintf(Message, "Please see system log file for more information...\n");
    fprintf(Message, "==================================================\n");
    fclose(Message);
    if ((Mailer=fopen("/tmp/mailer", "w")) != NULL) {
      fprintf(Mailer, "#!/bin/sh\n"); 
      fprintf(Mailer, "/usr/ucb/Mail -s UPS-Daemon-ALERT %s < /tmp/UPSMess\n", MAILADR);
      fclose(Mailer);
      if ((Mailer=popen("/bin/sh /tmp/mailer", "w")) != NULL)
        pclose(Mailer);
      if ((Mailer=popen("/bin/rm -f /tmp/mailer", "w")) != NULL)
        pclose(Mailer);
    };
    if ((Mailer=popen("/bin/rm -f /tmp/UPSMess", "w")) != NULL)
      pclose(Mailer);
  };
};
